/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ConstanteDAO;
import com.rjconsultores.ventaboletos.entidad.Constante;

/**
 *
 * @author Administrador
 */
@Repository("constanteDAO")
@SuppressWarnings("unchecked")
public class ConstanteHibernateDAO extends GenericHibernateDAO<Constante, Integer>
        implements ConstanteDAO {

    @Autowired
    public ConstanteHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Constante> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("nombconstante"));

        return c.list();
    }

    public Constante buscarPorNomeConstante(String nomeConstante) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("nombconstante", nomeConstante));

        return (Constante) c.uniqueResult();
    }

    public List<Constante> buscar(String nombconstante) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("nombconstante", nombconstante));

        return c.list();
    }
       
    public List<Constante> buscarPorNomeConstanteLike(String nombconstante) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.ilike("nombconstante", "%" + nombconstante + "%"));

        return c.list();
    }
}
